//+------------------------------------------------------------------+
//|                                                      Bimodal.mq4 |
//|                         Copyright 2018, Marius Ovidiu Sunzuiana. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, Marius Ovidiu Sunzuiana."
#property link      "https://www.mql5.com"
#property version   "1.777"

extern string StartHour="11:00";
extern string EndHour="20:00";

extern bool StandardMODE=true;
extern bool RandomMODE=false;
extern double takeprofit=0.0080;
extern double stoploss=0.0030;
extern double lot=0.01;

int magicnumber=777;
int total=OrdersTotal();
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---

   MessageBox("Default is set to StandardMODE");
   if(Bars<100)
     {
      Print("Not enough bars for EA to trade");
      return(0);
     }
   Calculatedigits(Symbol());
   Comment("BIMODAL BALANCE : "+AccountBalance());
   if(IsDemo()==false)
     {
      Alert("Bimodal EA is set on live account");
     }
   else
     {
      Alert("Bimodal EA is set on demo account");
     }

//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {



  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
    
   
   if(RandomMODE==true)
   
     {
      if(CalculateRandom()==0 && CountOrder(OP_BUY) == 0)
         OrderSend(Symbol(),OP_BUY,lot,Ask,4,(Ask-stoploss),(Ask+takeprofit),NULL,magicnumber,0,clrDeepPink);
      


     }
   else if(StandardMODE==true)
     {
     
      double sar1;
      sar1=iSAR(Symbol(),0,0.02,0.2,0);
      if(Close[0]<sar1 && CountOrder(OP_BUY) == 0)
        {

         OrderSend(Symbol(),OP_BUY,lot,Ask,4,(Ask-stoploss),(Ask+takeprofit),NULL,magicnumber,0,clrDeepPink);
        }



     }



  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CalculateRandom()
  {
   MathSrand(GetTickCount());
   double random=MathRand()%2;
   return random;

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Calculatedigits(string currency)
  {
   int digits=MarketInfo(currency,MODE_DIGITS);
   if(digits==2 || digits==3)
      return 0.01;
   else if(digits==3 || digits==5)
      return 0.0001;

  }
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
int CountOrder(int Order_Type) {
   int orders=0;
   for(int i=OrdersTotal()-1;i>=0;i--){
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==false) continue;
      if(OrderSymbol()!=_Symbol || OrderMagicNumber() != magicnumber) continue;
      if(Order_Type == OrderType() || Order_Type == -1) orders++;
    }
   return(orders);
}